// DetailsThread.cpp: implementation of the CDetailsThread class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DetailsThread.h"
#include "encspot.h"
#include "mp3file.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDetailsThread::CDetailsThread(tstring path) : m_path(path)
{
	m_hMutex = CreateMutex(NULL,FALSE,NULL);
	m_hEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	m_hAbort = CreateEvent(NULL,TRUE,FALSE,NULL);
}

CDetailsThread::~CDetailsThread()
{
	WaitForSingleObject(m_hEvent, INFINITE);
	CloseHandle(m_hMutex);
	CloseHandle(m_hEvent);
	CloseHandle(m_hAbort);

}
 

void CDetailsThread::Main()
{

	//callback sink for CMp3File::ProcessFrames	
	struct thread_helper : public CMp3File::sink
	{
		HWND hwnd;
		HANDLE m_hAbort;
		BOOL Fire(const mp3data &data) const
		{
			if (WaitForSingleObject(m_hAbort, 0)==WAIT_OBJECT_0)
				return FALSE;
			
			mp3data *pData = new mp3data(data);
			::PostMessage(hwnd, WM_USER+5,0,(LPARAM)pData);
			return TRUE;
		}
	};



	mp3data data;
	memset(&data, 0, sizeof(mp3data));


	thread_helper help;
	help.hwnd = m_hWndPar;
	help.m_hAbort = m_hAbort;

	CMp3File mp3;
	if (!mp3.Open(m_path))
	{
		SetEvent(m_hEvent);		//signal we're all done...
		tstring err = _T("File not found:\r\n") + m_path;
		MessageBox(GetActiveWindow(),err.c_str(),0,0);
		KillTimer(m_hWndPar, 0);
		DestroyWindow(m_hWndPar);
		return;


	}
	try
	{
		mp3.ProcessFrames(data, -1, &help);
	}
	catch(const char *szError)
	{
		mp3.Close();
		MessageBox(GetActiveWindow(), szError, NULL,NULL);
		KillTimer(m_hWndPar,0);
		PostMessage(m_hWndPar, WM_CLOSE, NULL,NULL);
		
	}
	SetEvent(m_hEvent);		//signal we're all done...
}
