// EncSpot.cpp : main source file for EncSpot.exe
//

#include "stdafx.h"
#include <atlwin.h>
#include <atldlgs.h>
#include "encspot.h"
#include "EncSpotShellSupport/pidl.h"
#include "EncSpotLib/interface.h"
#include "EncSpotLib/WinFactory.h"





BOOL g_logging;
TCHAR g_version[256];
tstring g_cmdline;


CAppModule _Module;
 
int Run(LPTSTR lpstrCmdLine, int nCmdShow = SW_SHOWDEFAULT)
{
	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

	CFrameWindowStuff *pwndMain = CWinFactory::Instance().Create(WID_MAINFRAME);


	if(pwndMain->CreateImp() == FALSE)
	{
		ATLTRACE(_T("Main window creation failed!\n"));
		return 0;
	}


	int nRet = theLoop.Run();

	_Module.RemoveMessageLoop();

	delete pwndMain;
	return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = ::OleInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

#if (_WIN32_IE >= 0x0300)
	INITCOMMONCONTROLSEX iccx;
	iccx.dwSize = sizeof(iccx);
	iccx.dwICC = ICC_COOL_CLASSES | ICC_BAR_CLASSES;
	BOOL bRet = ::InitCommonControlsEx(&iccx);
	bRet;
	ATLASSERT(bRet);
#else
	::InitCommonControls();
#endif

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	g_cmdline = lpstrCmdLine;

	TCHAR path[MAX_PATH];
	GetModuleFileName(_Module.GetModuleInstance(),path, sizeof(path));

	DWORD len = GetFileVersionInfoSize(path,0);
	BYTE *pInfo = new BYTE[len];
	GetFileVersionInfo(path, 0, len, pInfo);

	BYTE *pSub = NULL;
	UINT leng;
	VerQueryValue(pInfo, _T("\\"), reinterpret_cast<void **>(&pSub), &leng);
	if (leng == sizeof(VS_FIXEDFILEINFO ))
	{
		VS_FIXEDFILEINFO info;
		memcpy(&info, pSub, sizeof(VS_FIXEDFILEINFO ));
		int version			= HIWORD(info.dwProductVersionMS);
		int subversion		= LOWORD(info.dwProductVersionMS);
		int subsubversion	= HIWORD(info.dwProductVersionLS);

		lstrcpy(g_version, _T("EncSpot "));
		TCHAR v[10];
		lstrcat(g_version, _itot(version,v,10));
		lstrcat(g_version, _T("."));
		lstrcat(g_version, _itot(subversion,v,10));
		if (subsubversion)
			lstrcat(g_version, _itot(subsubversion,v,10));

	}


	delete[] pInfo;





	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::OleUninitialize();

	return nRet;
}



mp3data_string::update(const mp3data &data, BOOL monoquality)
{
	TCHAR b[100];

	mode		= get_mode(data.mode);
	length		= convert_time(data.length);

	vbr = data.vbr?_T("yes"):_T("no");
	cue = data.cue?_T("yes"):_T("no");

	//type
	type = _T("mpeg ");
	type += data.base_lsf?_T("2"):_T("1");
	type += _T(" ") + tstring(_T("layer ")) + tstring(data.layer,_T('I'));

	//frames
	frames = _itot(data.frameCount,b,10);
	if (!data.all_read)
		frames+=_T("+");


	//scalefac
	int scale = 0;
	int grancount= data.base_lsf?1:2;
	if (data.frameCount)
		scale = (data.scalefac * 100) / (grancount * (data.nch?data.nch:2) * data.frameCount);
	scalefac = scale?_itot(scale,b,10) + tstring(_T("%")):_T("not used");

	emphasis = (data.emphasis == 0 ? _T("none") : data.emphasis == 1 ? _T("50/15ms") : _T("CCITT")); 
	

	encoder  = guessenc(data);


	//filesize

	fsize = _itot(data.fsize,b,10);
	if (data.fsize > 999)
	{
		fsize.insert(fsize.size() - 3,_T(","));
		if (data.fsize > 999999)
			fsize.insert(fsize.size() - 7,_T(","));
	}

	//cut
	complete = get_complete(data);

	freq			= _itot(data.base_freq, b,10);
	max_reservoir	= _itot(data.max_reservoir,b,10);
	bitrate			= _itot(data.bitrate, b,10);
	sync_errors		= _itot(data.sync_errors, b, 10);


	//uses data already calculated
	quality			= get_quality(data, monoquality);

}


tstring mp3data_string::convert_time(const double secs)
{
	TCHAR t[20];
	SYSTEMTIME time;
	ZeroMemory(&time, sizeof(time));
	int s = (int)secs;
	time.wSecond = s % 60;
	time.wMinute = (s / 60) % 60;
	time.wHour   = s / (60 * 60);
	GetTimeFormat(LOCALE_USER_DEFAULT,TIME_FORCE24HOURFORMAT,&time,_T("hh':'mm':'ss"),t,sizeof(t));
	tstring ret = t;
	TCHAR b[4];
	int milli = ((int)((secs - s) * 1000))/100; 
	if (s < 10)
		ret+=_T(".")+tstring(_itot(milli,b,10));
	return ret;
}

tstring mp3data_string::get_mode(int mode)
{
	switch (mode)
	{
	case MPG_MD_STEREO: 
		return _T("stereo");
		break;
	case MPG_MD_JOINT_STEREO:
		return _T("joint stereo");
		break;
	case MPG_MD_DUAL_CHANNEL:
		return _T("dual channel");
		break;
	case MPG_MD_MONO:
		return _T("mono");
		break;
	}

	return _T("");
}




tstring mp3data_string::guessenc(const mp3data &data)
{
	BOOL fullguess = data.all_read;

//still not recognized: Gogo
	
	tstring guess;
	tstring label = data.label;
	guess = _T("Unknown");

	if (label == _T("FhG"))
		return guess = _T("FhG (fastenc)");

	if (label.find(_T("Lame"))!=string::npos)
		return guess = label;

//no identification string found

		if (data.blockCount[1] == 0)			//no short blocks 
		{
			if (data.mode == MPG_MD_DUAL_CHANNEL) // (note by GB: dual channel and no short: probably a very bad encoder ;-)
			{
				if (data.scfsi)  //scfsi used
				{ }
				else
				{		//no scfsi
					if (data.scalefac > 0) 
					{ }
					else //scalefactors not used
						return guess = _T("Shine");
				}
			}
			else
			{	//no dual channel
				if ( (data.modeCount[1]) || (data.modeCount[3]) )				//intensity stereo!
					return guess = _T("Xing (very old)");
				else
				{								//no intensity stereo
					if (data.scfsi)				//scfsi => new Xing
						return guess = _T("Xing (new)");
					else
					{							//no scfsi
						if (data.mode == MPG_MD_JOINT_STEREO)		//joint stereo: can't be Xing: prob FhG
						{
							if (data.modeCount[0])				//also includes some stereo frames
							{
								if (data.padding)
								{
									if (data.original)
										return guess = _T("FhG (l3enc)");
									else
										return guess = _T("FhG (fastenc or mp3enc)");
								}
								else	//no padding
									return guess = _T("FhG (ACM or producer pro)");
							}
							else	//no stereo frames: forced joint
							{
								if ((data.padding) && !(data.original) && !(data.copyright))
									return guess = _T("QDesign (fast mode)");
							}

						}
						else
							return guess = _T("Xing (old)");
					}
				}
			}
		} 
		else	
		{					 //short blocks
			if (data.scfsi)  //scfsi used
			{
				if (data.scalefac > 0) 
					return guess = _T("Lame");
				else 
					return guess = _T("Lame (old) or m3e");
			} 
			else			//no scfsi
			{
				if (data.scalefac > 0) 
				{
					if (data.padding)
					{
						if (data.original)
							return guess = _T("FhG (l3enc)");
						else
							return guess = _T("FhG (fastenc or mp3enc)");
					}
					else	//no padding
                        if (data.vbr)
                            return guess = _T("FhG (fastenc)");
                        else
						    return guess = _T("FhG (ACM or producer pro)");
				} 
				else
				{			//scalefactors not used
					if (data.mode == MPG_MD_JOINT_STEREO)
					{
						if ((data.padding) && !(data.original) && !(data.copyright))
							return guess = _T("QDesign");
					}
					if (data.mode == MPG_MD_DUAL_CHANNEL)
					{
						if (data.padding)
							return guess = _T("Blade");
						else
							return guess = _T("dist10 encoder or other encoder");
					}
					//either mono or plain stereo
					if (fullguess)
                    {
						if (data.padding)
						    return guess = _T("Blade");
					    else
						    return guess = _T("dist10 encoder or other encoder");
                    }
                    else
                    {
                        if (data.max_reservoir < 80) //ISO based encoders are unable to properly use bit reservoir
					    {/*this bit reservoir thing seems to not beeing a good criterion in each case
					    perhaps computing average bit reservoir could help?*/
						    if (data.padding)
						    	return guess = _T("Blade");
					    	else
						    	return guess = _T("dist10 encoder or other encoder");
					    }
                    }
				}
			}
		}
	


	return guess;


}



tstring get_desktop_path()
{

	TCHAR path[MAX_PATH];

	CPidl pidl;
	SHGetSpecialFolderLocation(GetActiveWindow(),CSIDL_DESKTOPDIRECTORY, &pidl.m_pidl);
	SHGetPathFromIDList(pidl, path);
	pidl.Free();

	return path;
}



void log(tstring text)
{
	TCHAR fname[MAX_PATH];
	::GetModuleFileName(_Module.m_hInst,fname, MAX_PATH);
	PathRemoveExtension(fname);

	tstring fn = fname + tstring(_T(".log"));
	FILE *file = _tfopen(fn.c_str(),_T("a+"));	//append
	fwrite((text + _T("\n")).c_str(),sizeof(TCHAR), text.size()+1,file);
	fclose(file);

}



int mp3data_string::get_quality(const mp3data &data, BOOL monoquality )
{
	MYASSERT(!encoder.empty());

	tstring enc = encoder;
	int br		= data.bitrate;

	vector<tstring> good,bad;
	good.push_back(_T("FhG"));
	good.push_back(_T("Lame"));
	bad.push_back(_T("Blade"));
	bad.push_back(_T("dist"));
	bad.push_back(_T("QDesign (fast mode)"));
	bad.push_back(_T("Shine"));
	bad.push_back(_T("Xing"));

	


	//good, bad or neutral.
	int test1 = 0;
	for (int i = 0;i<good.size();i++)
	{
		if (enc.find(good[i])!=tstring::npos)
			test1 = 1;
	}
	for (i = 0;i<bad.size();i++)
	{
		if (enc.find(bad[i])!=tstring::npos)
			test1 = -1;
	}

	int bits[16];
	memcpy(bits,tabsel_123[data.base_lsf][data.layer-1],sizeof(bits));

	//128,32,40,48, 56, 64, 80, 96,112,128,160,192,224,256,320

	double effective_bits = br;
	if (mode == _T("mono") &&  monoquality )
		effective_bits*=1.85;	//mono could be considered as "half bitrate-equal quality" against plain stereo, but only around 1.85 against joint stereo
	if (mode == _T("stereo"))
		effective_bits*=0.9;


	if (data.vbr)
		effective_bits*=1.2;

	if (effective_bits > bits[10 - test1] ) 
		return 2;
	else if (effective_bits > bits[8 - test1] )
		return 1;
	else
		return 0;

}

tstring mp3data_string::get_complete(const mp3data &data)
{
	tstring ret;

	if (data.complete2)
		ret = _T("yes");
	else
	{
		if (encoder.find(_T("Lame"))!=string::npos)
			ret = _T("no");
		else if (encoder.find(_T("FhG"))!=string::npos)
			ret = _T("no");
		else if (encoder.find(_T("Blade"))!=string::npos)
			ret = _T("yes");
		else ret = _T("maybe");
	}
	return ret;		
}
