// EncSpot.h

#include "stdafx.h"	// Added by ClassView
#pragma once


#define XING_FRAMES_FLAG	1
#define XING_BYTES_FLAG		2
#define XING_TOC_FLAG		4
#define XING_VBR_SCALE_FLAG	8

struct xing
{
	char		header_sync[4];		//"Xing"
	int			flags;				//see above...
	int			frames;				//number of frames
	BYTE	    toc[100];			//table of contents
	int			scale;				//?
};


struct mp3data
{
	TCHAR label[256];
	
	int bitrateCount[16];
	int blockCount[3];
	int modeCount[4];
	int frameCount;
	int length;
	
	int  fsize;
	int	 base_freq;
	int	 base_lsf;
	int	 nch;
	int  layer; 
	
	int mode;

	int max_reservoir;
	int sync_errors;

	BOOL padding;
	BOOL scfsi;
	BOOL scalefac;
	BOOL copyright;
	BOOL original;

	BOOL vbr;
	BOOL cue;

	BOOL complete_old;
	BOOL complete2;

	BOOL all_read;

	int emphasis;
	int bitrate;

	BOOL xing_present;
	xing xing_header;
	

};



class mp3data_string
{
public:
	tstring encoder;
	tstring length;
	tstring mode;
	tstring scalefac;
	tstring emphasis;
	tstring bitrate;
	tstring type;
	tstring fsize;
	tstring frames;
	tstring freq;
	tstring max_reservoir;
	tstring complete;
	tstring vbr;
	tstring cue;
	tstring sync_errors;
	
	int quality;

	mp3data_string() : quality(-1) {}
	update(const mp3data &data, BOOL monoquality);

private:
	tstring get_complete(const mp3data &data);

	tstring get_mode(int mode);
	tstring convert_time(const double secs);
	tstring guessenc(const mp3data &data);
	int		get_quality(const mp3data &data, BOOL monoquality );

};

#define MPG_MD_STEREO       0
#define MPG_MD_JOINT_STEREO 1
#define MPG_MD_DUAL_CHANNEL 2
#define MPG_MD_MONO         3



//#define MYFUNCTION (void (__cdecl *)(struct mp3data &,struct HWND__ *))


extern const int tabsel_123[2][3][16];
extern const long freqs[9];
extern BOOL g_logging;
extern TCHAR g_version[256];


tstring get_desktop_path();
void log(tstring text);


