
#pragma once



class IDropTargetImpl : public IDropTarget
{
protected:
	
	bool CheckFormat(IDataObject * pDataObject, CLIPFORMAT  cfFormat)
	{
		//work out what format it is
		IEnumFORMATETC *pEnum = NULL;

		pDataObject->EnumFormatEtc(DATADIR_GET ,&pEnum);
		HRESULT hr;
		FORMATETC form;


		bool ok = false;
		while ((hr = pEnum->Next(1,&form,NULL)) == S_OK)
		{
			if (form.cfFormat == cfFormat)
			{
				return true;
				break;
			} 
		}
		pEnum->Release();
		return false;
		
	}

public:

	STDMETHOD(DragEnter)(IDataObject * pDataObject,  //Pointer to the interface of the source data object
						 DWORD grfKeyState,			 //Current state of keyboard modifier keys
						 POINTL pt,         //Current cursor coordinates
						 DWORD * pdwEffect  //Pointer to the effect of the drag-and-drop operation
						 ) { return S_OK; }

	STDMETHOD(DragOver)(DWORD grfKeyState, //Current state of keyboard modifier keys
						POINTL pt,         //Current cursor coordinates
						DWORD * pdwEffect  //Pointer to the effect of the drag-and-drop operation
						) { return S_OK; }					
 
	STDMETHOD(DragLeave)() { return S_OK; }

	STDMETHOD(Drop)(IDataObject * pDataObject,  //Pointer to the interface of the source data object
						 DWORD grfKeyState,			 //Current state of keyboard modifier keys
						 POINTL pt,         //Current cursor coordinates
						 DWORD * pdwEffect  //Pointer to the effect of the drag-and-drop operation
						) { return S_OK; }



};




class IDropSourceImpl : public IDropSource
{
public:

   STDMETHOD(GiveFeedback)(DWORD) {	return DRAGDROP_S_USEDEFAULTCURSORS; }
     
   STDMETHOD(QueryContinueDrag)(BOOL fEscapePressed, DWORD grfKeyState)
   {
	   if(fEscapePressed)
		   return DRAGDROP_S_CANCEL;

		if(!(grfKeyState & MK_LBUTTON))
		   return DRAGDROP_S_DROP;

		return S_OK;
   }
};
