#pragma once


class CListViewBarCtrl : public CListViewCtrl
{
	int m_border, m_mar;
public:

	CListViewBarCtrl() : m_nBarPos(-1), m_bBarActive(FALSE), m_cBarColor(RGB(255,0,0)), m_border(0), m_mar(4) {}

	int m_nBarPos;
	BOOL m_bBarActive;
	COLORREF m_cBarColor;


	void EraseBar()
	{
		if (!m_bBarActive || GetItemCount() == 0)
			return;

		RECT r;
		int left,right,vert;
		GetCoords(left,right,vert);
		r.left = left;
		r.right= right;
		r.top  = vert-1;
		r.bottom=vert+1;

		CWindow wPar = GetParent();
		wPar.RedrawWindow(&r);

		r.left = r.right;
		r.right+=m_mar + 4;
		r.top  -= m_mar;
		r.bottom+=m_mar;

		wPar.RedrawWindow(&r);

		r.left = left - m_mar - 4;
		r.right= left;

		wPar.RedrawWindow(&r);

	}

	void GetCoords(int &left, int &right, int &vert)
	{

		RECT r;
		if (m_nBarPos==-1)
		{
			GetItemRect(GetItemCount() -1 , &r,LVIR_LABEL);
			r.top = r.bottom;
		}
		else
			GetItemRect(m_nBarPos , &r,LVIR_LABEL);

		ClientToScreen(&r);
		CWindow wPar = GetParent();
		wPar.ScreenToClient(&r);

		RECT r2;
		GetWindowRect(&r2);
		wPar.ScreenToClient(&r2);

		left = r2.left - m_border;
		right= r2.right+ m_border;
		vert = r.top;
	}


	void DrawBar()
	{
		
		if (!m_bBarActive || GetItemCount() == 0)
			return;

		CWindow wPar = GetParent();
		CDCT<true> dc = wPar.GetDC();

		CPenT<false> hOld;
		CPenT<true>  hNew;
		CPenT<true>  hNewSolid;

	
		hNew.CreatePen(PS_DASH,1, m_cBarColor );
		hNewSolid.CreatePen(PS_SOLID,1, m_cBarColor );
	

		

		hOld = (HPEN)::SelectObject(dc, hNew);
		

		int left,right,vert;
		GetCoords(left,right, vert);

		dc.MoveTo(left,			vert);
		for (int i = left; i<right;i++)
		{
			int r = i%5;
			if ((r!=3) && (r!=4) && (r!=5))
			{
				dc.MoveTo(i-1,vert);
				dc.LineTo(i,vert);
			}
		}


		dc.LineTo(right,		vert);

		::SelectObject(dc, hNewSolid);

		//triangles
		dc.LineTo(right + m_mar,  vert + m_mar);
		dc.LineTo(right + m_mar,  vert - m_mar-1);
		dc.MoveTo(right		 , vert);
		dc.LineTo(right + m_mar,  vert - m_mar);
		dc.MoveTo(right + m_mar - 1, vert + m_mar - 1);
		dc.LineTo(right + m_mar - 1, vert - m_mar + 1);

		dc.MoveTo(left,			vert);
		dc.LineTo(left - m_mar,  vert + m_mar);
		dc.LineTo(left - m_mar,  vert - m_mar-1);
		dc.MoveTo(left		 , vert);
		dc.LineTo(left - m_mar,  vert - m_mar);
		dc.MoveTo(left - m_mar + 1, vert + m_mar - 1);
		dc.LineTo(left - m_mar + 1, vert - m_mar + 1);


		CPenT<true>  hNewThick;
		LOGBRUSH lb;
		lb.lbColor = m_cBarColor;
		lb.lbStyle = BS_SOLID;

		hNewThick.CreatePen(PS_SOLID | PS_GEOMETRIC | PS_ENDCAP_SQUARE,3,&lb,0,NULL);
		::SelectObject(dc, hNewThick);

		dc.MoveTo(right+2		   , vert);
		dc.LineTo(right + m_mar + 2, vert);

		dc.MoveTo(left-2		   , vert);
		dc.LineTo(left - m_mar  - 2, vert);



		::SelectObject(dc, hOld);
	}

};
