#pragma once

#include <algorithm>



#ifndef MYASSERT
#define MYASSERT(expr) _ASSERTE(expr)
#endif


//why the hell isnt this is commctrl.h?	:)

#ifdef UNICODE
#define  LPNMLVDISPINFO           LPNMLVDISPINFOW
#else
#define  LPNMLVDISPINFO           LPNMLVDISPINFOA
#endif


//owner data listview

template <class X>
class CListViewVirt: public CListViewCtrl			//X = data to be stored in list...usually a struct
{

	typedef CListViewVirt<X> CThis ;

	
	class sortpredicate
	{
	
		PFNLVCOMPARE pfnCompare;
		LPARAM lParam;

	public:
		sortpredicate(PFNLVCOMPARE pfnComp, LPARAM lP) : pfnCompare(pfnComp), lParam(lP) {}
		BOOL operator()(const X *var1, const X *var2) const 
		{
			return (pfnCompare((LPARAM)var1, (LPARAM)var2, lParam)==-1);
		}

	};

	vector<X *>	m_itemdata;

public:

	BOOL SortItems(PFNLVCOMPARE pfnCompare, LPARAM lParamSort)
	{

		sort(m_itemdata.begin(), m_itemdata.end(), sortpredicate(pfnCompare, lParamSort));
	
		return TRUE;


	}


	virtual ~CListViewVirt()
	{
		int n = m_itemdata.size();
		for (int i = 0;i<m_itemdata.size();i++)
		{
			X *pX = m_itemdata[i];
			X *pY = m_itemdata[8];
			delete pX;
		}
	}

	int size() { return m_itemdata.size(); }

	X & CreateNewData(X in)
	{
		X *pRet = new X(in);
		m_itemdata.push_back(pRet);
		return *pRet;
	}

	X & CreateNewData()
	{
		X *pRet = new X;
		m_itemdata.push_back(pRet);
		return *pRet;
	}


	

	void ReinsertOurItem(int nThis, int nInsert)
	{
		MYASSERT(nThis   <  m_itemdata.size());
		MYASSERT(nInsert <= m_itemdata.size());

		X *pThis = m_itemdata[nThis];

		if (nInsert == m_itemdata.size())
		{
			m_itemdata.push_back(pThis);
			m_itemdata.erase(m_itemdata.begin() + nThis);
		}
		else
		{
			m_itemdata.insert(m_itemdata.begin() + nInsert, pThis);

			if (nInsert > nThis)
				m_itemdata.erase(m_itemdata.begin() + nThis);
			else
				m_itemdata.erase(m_itemdata.begin() + nThis+1);
		}	
	}

	void DeleteItem(int i)
	{
		delete m_itemdata[i];
		m_itemdata.erase(m_itemdata.begin() + i, m_itemdata.begin() + i + 1);
		SetItemCount(GetItemCount()-1);
	}

	X &GetItemData(int i) { return *m_itemdata[i]; }

	int FindItemByData(const X &data)
	{
		for (int i = 0;i<m_itemdata.size();i++)
		{
			if (*m_itemdata[i] == data)
				return i;
		}

		return -1;
	}

	void DeleteAllItems()
	{
		SetItemCount(0);
		for (int i = 0;i<m_itemdata.size();i++)
			delete m_itemdata[i];

		m_itemdata.clear();
		
	}
};





/*


#define BEGIN_LIST_DATA_MAP(T, X)  const static LVITEMMAP *_GetListMap(int *pSize = NULL){			\
static const X testdata; static const LVITEMMAP m_columnmap[] = { 
#define LIST_DATA_INT(d, i, m)		LVITEMMAP(d, i, integer, ((BYTE *)(&testdata.m) - (BYTE *)&testdata)),	
#define LIST_DATA_TSTRING(d, i, m)		LVITEMMAP(d, i, str, ((BYTE *)(&testdata.m) - (BYTE *)&testdata)),	
#define END_LIST_DATA_MAP()		};	if (pSize) *pSize = sizeof(m_columnmap) / sizeof(LVITEMMAP);  return m_columnmap; }*/

#define BEGIN_LIST_DATA_MAP(T, X) void _ExtremeConstructMap() {						\
			static const X testdata;	
#define LIST_DATA_INT(id, header, member)	 m_allcolumns[id] =						\
			LVCOLUMNDATA(header, integer, 100,((BYTE *)(&testdata.member) - (BYTE *)(&testdata)));		\
			m_ids.push_back(id);
#define LIST_DATA_TSTRING_EX(id, header, member)	 m_allcolumns[id] =						\
			LVCOLUMNDATA(header, str, 100, ((BYTE *)(&testdata.member) - (BYTE *)(&testdata))  );		\
			m_ids.push_back(id);

#define LIST_DATA_TSTRING(id, header, member,width)	 m_allcolumns[id] =						\
			LVCOLUMNDATA(header, str, width, ((BYTE *)(&testdata.member) - (BYTE *)(&testdata))  );		\
			m_ids.push_back(id);


#define LIST_DATA_TSTRING_SPECIALSORT(id, header, member,sortmember, width)	 m_allcolumns[id] =						\
			LVCOLUMNDATA(header, str, width, ((BYTE *)(&testdata.member) - (BYTE *)(&testdata)),((BYTE *)(&testdata.sortmember) - (BYTE *)(&testdata))  );		\
			m_ids.push_back(id);

#define END_LIST_DATA_MAP()		}



//listview with dynamic columns

template <class T, class W = CListViewCtrl>		//X = data type, W = base e.g. CListViewCtrl
class CListViewExtremeImpl : public CWindowImpl<T, W>
{

	T *This;

	 //ids of columns currently visible
	vector<DWORD>				m_chids;

protected:


	enum DataType { integer, str };


		
	class LVCOLUMNDATA
	{
	public:
		LVCOLUMNDATA() {}
		LVCOLUMNDATA(tstring txt, DataType t, int wid, int o, int s = -1) : header(txt), type(t), width(wid), offset(o) , offsetsort(s){}
		BOOL operator==(LVCOLUMNDATA &other)
		{
			return (text == other.text);
		}

		tstring	header;
		int		width;

	private:
		int offset;
		int offsetsort;
		DataType type;


	friend class CListViewExtremeImpl<T,W>;

	};

	typedef LVCOLUMNDATA * LPLVCOLUMNDATA;
	typedef map<DWORD, LVCOLUMNDATA> datamap;

	datamap		m_allcolumns;  //dynamic column info

	//ids of columns
	vector<DWORD> m_ids;
	
	BOOL	IsColumnVisible(DWORD id) {	return (find(m_chids.begin(), m_chids.end(), id) != m_chids.end()); }
	int		GetColumnWidthById(DWORD id){ return m_allcolumns[id].width; }
	int		GetIdOfSubitem(int subitem) { return m_chids[subitem]; }

public:

		

	void DeleteAllColumns()
	{
		for (int i = GetColumnCount()-1;i>=0;i--)
			DeleteColumn(i);
		m_chids.clear();
	}

		
	void StoreColumnWidths()
	{
		for (int i = 0;i<m_chids.size();i++)
			m_allcolumns[m_chids[i]].width = GetColumnWidth(i);
	}

	void DisplayColumn(DWORD id, int width = 0)
	{
		m_chids.push_back(id);
		if (width)
			m_allcolumns[id].width = width;
	}

	//resize column  col so that columns fit client rect exactly
	void AutoSize(int col, int min = 0)
	{
		RECT r;
		GetClientRect(&r);

		int n=0;
		for (int i = 0;i<m_chids.size();i++)
			n+=GetColumnWidth(i);

		int m = GetColumnWidth(col);
		int new_width = r.right - n + m;
		SetColumnWidth(col, max(new_width,min));
	}


	int		GetColumnCount() { return m_chids.size(); }
	
	//slow
	DWORD GuessIdFromHeader(tstring text)
	{
		for (int i = 0;i<m_ids.size();i++)
		{
			if (m_allcolumns[m_ids[i]].header == text)
				break;
		}

		MYASSERT(i < m_allcolumns.size());


		return m_ids[i];
	}

	CListViewExtremeImpl<T,W>() : This( (T *)this)
	{
		//if this gives compile error then you probably omitted LIST_DATA_MAP
		This->_ExtremeConstructMap();
	}

	//get number of _potential_ columns....
	int GetColumnPoolSize() 
	{ 
		return m_allcolumns.size();
	}

	//get the i'th id.... i != subitem....
	int GetId(int i)
	{
		int s = m_ids.size();
		return m_ids[i];
	}

	//get header of potential column from its id
	tstring GetColumnHeaderById(int id)
	{
		return m_allcolumns[id].header;
	}

	void SetItemTextById(tstring txt, int colid, LPARAM lParam)
	{
		
		int offset		= m_allcolumns[colid].offset;
		DataType type	= m_allcolumns[colid].type;

		BYTE *pData = (BYTE *)(lParam) + offset;
		if (type!=str)
			return;

		*(tstring *)pData = txt;
	}
	

	
	tstring GetItemTextById(int colid, LPARAM lParam)
	{
		tstring ret;
		int offset		= m_allcolumns[colid].offset;
		DataType type	= m_allcolumns[colid].type;

		BYTE *pData = (BYTE *)(lParam) + offset;
		switch(type)
		{
		case integer:
			TCHAR b[256];
			ret = _itot( *(int *)pData,b,10);
			break;

		case str:
			ret = *(tstring *)pData;
			break;

		default:
			throw _T("Error!! :)");
		}

		return ret;

	}
	
	static int CALLBACK ExtremeListViewCompareProc(LPARAM lparam1, LPARAM lparam2,LPARAM lparamSort)
	{
		LPLVITEMDATA lplvid1=(LPLVITEMDATA)lparam1;
		LPLVITEMDATA lplvid2=(LPLVITEMDATA)lparam2; 

		T *This = (T *)lparamSort;
		DWORD colid = This->m_idSort;

	
		int offset		= This->m_allcolumns[colid].offset;
		int offsetsort	= This->m_allcolumns[colid].offsetsort;
		DataType type = This->m_allcolumns[colid].type;

		BYTE *pData1 = (BYTE *)(lparam1) + offset;
		BYTE *pData2 = (BYTE *)(lparam2) + offset;

		if (offsetsort !=-1)
		{
			pData1 = (BYTE *)(lparam1) + offsetsort;
			pData2 = (BYTE *)(lparam2) + offsetsort;

			type = integer;

			int i1, i2;
			i1 = *(int *)pData1;
			i2 = *(int *)pData2;
		}

		switch(type)
		{
		case integer:
			if(!This->m_bReverseSort)
				return (*(int *)pData1 < *(int *)pData2 )?-1:1;
			else
				return (*(int *)pData1  > *(int *)pData2 )?-1:1;
		case str:
			{
				const TCHAR *s1, *s2;
				s1 = ((tstring *)pData1)->c_str();
				s2 = ((tstring *)pData2)->c_str();

				if(!This->m_bReverseSort) 
					return lstrcmpi(s1,s2);
				else
					return lstrcmpi(s2,s1);
			}
		}

		return 0;
	}
};