#pragma once

#include "inifile.h"

typedef CPropertySheet CSettingsDlg;

interface CWindowWithSettings
{
	virtual void SaveSettings(CIniFile &ini)=0;
	virtual void LoadSettings(const CIniFile &ini)=0;
	virtual void InitPropPages(BOOL *pDirty) {}
	virtual void ApplyPropPageChanges(BOOL dirty) {}
	virtual void AddPropPages(CSettingsDlg *pDlg) {}
	virtual ~CWindowWithSettings() {}
	
};

interface CFrameWindowStuff
{
	virtual BOOL PreTranslateMessage(MSG* pMsg) = 0;
	virtual HWND CreateImp(HWND hWndParent = NULL, RECT *pPos=NULL) = 0;
	virtual ~CFrameWindowStuff() {}
	virtual HWND hWnd() = 0;

};

template<class T>
class CFrameWindowStuffImpl : public CFrameWindowStuff
{
public:

	virtual BOOL PreTranslateMessage(MSG* pMsg) { return FALSE; }
	virtual HWND CreateImp(HWND hWndParent = NULL, RECT *pPos=NULL) = 0;
	virtual ~CFrameWindowStuffImpl() {}
	virtual HWND hWnd()
	{
		T *pT = static_cast<T *>(this);
		return pT->m_hWnd;
	}


};