// DropTarget.h: interface for the CDropTarget class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DROPTARGET_H__C9DC7750_BE35_11D4_A175_080046068885__INCLUDED_)
#define AFX_DROPTARGET_H__C9DC7750_BE35_11D4_A175_080046068885__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EncSpotLib/DropImpl.h"

class CEncSpotList;

class CDropTarget : public CComObjectRoot, public IDropTargetImpl
{		
private:
	BOOL IsHDrop(IDataObject *pDataObject, FORMATETC &form)
	{

		//work out what format it is
		IEnumFORMATETC *pEnum = NULL;

		pDataObject->EnumFormatEtc(DATADIR_GET ,&pEnum);
		if (pEnum==NULL)
			return FALSE;


		HRESULT hr;

		BOOL ok = FALSE;
		while ((hr = pEnum->Next(1,&form,NULL)) == S_OK)
		{
			if (form.cfFormat == CF_HDROP)
			{
				ok = TRUE;
				break;
			} 
		}
		pEnum->Release();

		return ok;
	}
	vector<tstring> GetFilenames(IDataObject *pDataObject, FORMATETC &form)
	{

		vector<tstring> ret;

		CLIPFORMAT cf = CF_HDROP;
		form.tymed    = TYMED_HGLOBAL;
		form.dwAspect = DVASPECT_CONTENT;
		form.ptd      = NULL;
		form.lindex   = -1;


		STGMEDIUM stg;

		HRESULT hr = pDataObject->GetData(&form, &stg);
		if (FAILED(hr))
			return ret;

		HDROP hDrop = (HDROP)stg.hGlobal;
		
		int count = DragQueryFile(hDrop,-1,NULL,NULL);
		for (int n = 0;n<count;n++)
		{
			TCHAR b[MAX_PATH];
			DragQueryFile(hDrop,n,b,MAX_PATH);
			ret.push_back(b);
		}
			
		ReleaseStgMedium(&stg);

		



		return ret;
	}
public:
	
	HWND m_hWndMain;


	BEGIN_COM_MAP(CDropTarget)
		COM_INTERFACE_ENTRY(::IDropTarget)
	END_COM_MAP()

	STDMETHOD(DragEnter)(IDataObject * pDataObject,  //Pointer to the interface of the source data object
						 DWORD grfKeyState,			 //Current state of keyboard modifier keys
						 POINTL pt,         //Current cursor coordinates
						 DWORD * pdwEffect  //Pointer to the effect of the drag-and-drop operation
						 ) 
	{ 
		/*FORMATETC form;
		vector<tstring> filenames = GetFilenames(pDataObject, form);
		for (int i = 0;i<filenames.size();i++)
		{
			CString ext = PathFindExtension(filenames[i].c_str());
			ext.MakeLower();
			if (ext==".mp3")
				return S_OK;
		}

		return E_INVALIDARG; */
		return S_OK;
	}

	STDMETHOD(DragOver)(DWORD grfKeyState, //Current state of keyboard modifier keys
						POINTL pt,         //Current cursor coordinates
						DWORD * pdwEffect  //Pointer to the effect of the drag-and-drop operation
						) 
	{ 
		if ((grfKeyState & MK_CONTROL) && !(grfKeyState & MK_SHIFT))
			*pdwEffect = DROPEFFECT_COPY;
		else if (!(grfKeyState & MK_CONTROL) && (grfKeyState & MK_SHIFT))
			*pdwEffect = DROPEFFECT_MOVE;
			

		return S_OK; 
	}		

	STDMETHOD(Drop)(IDataObject * pDataObject,  //Pointer to the interface of the source data object
						 DWORD grfKeyState,			 //Current state of keyboard modifier keys
						 POINTL pt,         //Current cursor coordinates
						 DWORD * pdwEffect  //Pointer to the effect of the drag-and-drop operation
						)
	{

		FORMATETC form;

		if (!IsHDrop(pDataObject, form))
			return S_OK;

		vector<tstring> *pFilenames = new vector<tstring>;
		*pFilenames = GetFilenames(pDataObject, form);

		PostMessage(m_hWndMain,WM_DROP,grfKeyState,reinterpret_cast<LPARAM>(pFilenames));

		
		return S_OK;
	}

};

#endif // !defined(AFX_DROPTARGET_H__C9DC7750_BE35_11D4_A175_080046068885__INCLUDED_)
