// EncSpotTree.h: interface for the CEncSpotTree class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENCSPOTTREE_H__CC28F0BE_65B1_40B8_BE9D_BF92B6BCB0C6__INCLUDED_)
#define AFX_ENCSPOTTREE_H__CC28F0BE_65B1_40B8_BE9D_BF92B6BCB0C6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EncSpotShellSupport/pidl.h"
#include "EncSpotLib/interface.h"
#include "EncSpotLib\winfactory.h"


//from CEncSpotView	
#define WM_REFRESH		WM_USER+13

//to view
#define WM_FILLLVIEW	WM_USER+35
#define WM_DROP			WM_USER+4

class CEncSpotTree  :	public CWindowImpl<CEncSpotTree, CTreeViewCtrl>,
						public CFrameWindowStuffImpl<CEncSpotTree>,
						public CWindowWithSettings,
						public CCreator<CEncSpotTree, WID_TVIEW>
{
	CWindow *m_pMain;

	//application settings

	tstring					m_default_dir;
	BOOL					m_userecent;

	BOOL					m_bQuietSelect;

public:

	DECLARE_WND_SUPERCLASS(NULL, CTreeViewCtrl::GetWndClassName())

	BEGIN_MSG_MAP(CEncSpotTree)
		MESSAGE_HANDLER(WM_DESTROY,							OnDestroy)
		MESSAGE_HANDLER(WM_REFRESH,							OnRefresh)

		REFLECTED_NOTIFY_CODE_HANDLER(TVN_DELETEITEM,		OnDeleteItem)
		REFLECTED_NOTIFY_CODE_HANDLER(NM_RCLICK,			OnRClk)
		REFLECTED_NOTIFY_CODE_HANDLER(TVN_ITEMEXPANDING,	OnItemExpanding)
		REFLECTED_NOTIFY_CODE_HANDLER(TVN_SELCHANGED,	OnSelChanged)

		DEFAULT_REFLECTION_HANDLER( )
	END_MSG_MAP()
	
	CEncSpotTree(CWindow *pParent);
	virtual ~CEncSpotTree();

	//CFrameWindowStuff stuff
	HWND			CreateImp(HWND hWndParent = NULL, RECT *pPos=NULL);

	
	//CWindowWithSettings stuff

	void			SaveSettings(CIniFile &ini);
	void			LoadSettings(const CIniFile &ini);
	void			AddPropPages(CSettingsDlg *psheet);
	void			ApplyPropPageChanges(BOOL dirty);
	void			InitPropPages(BOOL *pDirty);

	CPropTree		m_proptree;

private:
	void FillRecursive(HTREEITEM hItem);
	void Refresh();
	
	//message handlers

	LRESULT OnDeleteItem(int , LPNMHDR pnmh, BOOL& );
	LRESULT OnRClk(int , LPNMHDR pnmh, BOOL& );
	LRESULT OnSelChanged(int , LPNMHDR pnmh, BOOL& );

	LRESULT OnItemExpanding(int , LPNMHDR pnmh, BOOL& );
	LRESULT OnRefresh(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/);
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);


	//internal stuff

	void			InitTreeView();
	HRESULT			AddItemToTree(	ULONG ulAttrs, 
									IShellFolder *pShellFolder, 
									CPidl lpi, 
									CComPtr<IMalloc> &spMalloc,
									CPidl lpifq, 
									HTREEITEM hParent);
	void			BeginExpand(tstring desktop, tstring defaultdir);
	HTREEITEM		ExpandToPath(HTREEITEM hItem, CPidl lpi);
	LRESULT			ExpandItem(LPTVITEM lptvi);
	HRESULT			FillTreeView(	IShellFolder * pShellFolder,
									LPITEMIDLIST  lpifq,
									HTREEITEM hParent);


	static int CALLBACK TreeViewCompareProc(LPARAM lparam1,LPARAM lparam2,LPARAM lparamSort);

};

#endif // !defined(AFX_ENCSPOTTREE_H__CC28F0BE_65B1_40B8_BE9D_BF92B6BCB0C6__INCLUDED_)
