#include "stdafx.h"
#include <atlwin.h>
#include <atldlgs.h>
#include <atlframe.h>
#include <atlctrls.h>

#include <atlsplit.h>

#include <atlmisc.h>

#include <algorithm>

#include "InfoDlg.h"

#include "Histogram.h"
#include "EncSpotShellSupport\Pidl.h"
template <class T> class CComObject;
#include "EncSpotView.h"
#include "itemdata.h"

#include <sys/types.h>
#include <sys/stat.h>

BOOL CEncSpotView::PreTranslateMessage(MSG* pMsg)
{
	/*HWND hwnd = pMsg->hwnd;
	for (int i = 0;i<m_infolist.size();i++)
	{
		if (m_infolist[i]->m_hWnd==hwnd)
		{
			MYTRACE_1(_T("msg: %i"),pMsg->message); 
			if (pMsg->message == WM_KEYDOWN)
			{
				int test = 1;
			}

		}
	}*/
	return FALSE;
}

CEncSpotView::CEncSpotView(CWindow *pMain) : m_pMain(pMain), m_nSplitterPos(180)
{
	m_pLView = CWinFactory::Instance().Create(WID_LVIEW, this);
	m_pTView = CWinFactory::Instance().Create(WID_TVIEW, this);	
}

CEncSpotView::~CEncSpotView()
{
	delete m_pLView;
	delete m_pTView;
}

LRESULT CEncSpotView::OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{

	m_nSplitterPos = GetSplitterPos();

	bHandled = FALSE;
	return 0;
}



LRESULT CEncSpotView::OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{
	bHandled = FALSE;

	m_pLView->CreateImp(m_hWnd,&rcDefault);
	m_pTView->CreateImp(m_hWnd, &rcDefault);

	SetSplitterPanes(m_pTView->hWnd(),m_pLView->hWnd());
	SetSplitterRect();
	SetSplitterPos(m_nSplitterPos);

	return 0;
}

void CEncSpotView::LoadSettings(const CIniFile &ini)
{
	dynamic_cast<CWindowWithSettings *>(m_pLView)->LoadSettings(ini);
	dynamic_cast<CWindowWithSettings *>(m_pTView)->LoadSettings(ini);
	
//	m_nSplitterPos = ini.GetInt(_T("view_settings"), _T("splitter_pos"),200);
}

void CEncSpotView::SaveSettings(CIniFile &ini)
{
	dynamic_cast<CWindowWithSettings *>(m_pLView)->SaveSettings(ini);
	dynamic_cast<CWindowWithSettings *>(m_pTView)->SaveSettings(ini);
	ini.SetInt(_T("view_settings"), _T("splitter_pos"),m_nSplitterPos);
}

LRESULT CEncSpotView::OnFillLView(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	::SendMessage(m_pLView->hWnd(), WM_FILL,wParam,lParam);
	return 0;
}


void CEncSpotView::Refresh()
{
	::SendMessage(m_pLView->hWnd(),WM_REFRESH,NULL,NULL);		
}


LRESULT CEncSpotView::OnDestroyInfoDlg(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
{	
	CInfoDlg *pInfo = reinterpret_cast<CInfoDlg *>(lParam);
	if (pInfo)
	{
		vector<CInfoDlg *>::iterator it = find(m_infolist.begin(), m_infolist.end(), pInfo);
		if (it!=m_infolist.end())
			m_infolist.erase(it);

		delete pInfo;
	}

	return 0;
}


LRESULT CEncSpotView::OnDrop(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{

	::PostMessage(m_pLView->hWnd(), WM_DROP, wParam, lParam);

	return 0;
}


LRESULT CEncSpotView::OnStop(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	//sent down from CMainFrame's menu
	::SendMessage(m_pLView->hWnd(),WM_STOP,NULL,NULL);
	return 0;
}

LRESULT CEncSpotView::OnRefresh(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	//sent down from CMainFrame's menu

	CRect rL, rT;
	::GetWindowRect(m_pLView->hWnd(), &rL);
	::GetWindowRect(m_pTView->hWnd(), &rT);

	CPoint pt;
	::GetCursorPos(&pt);

	if (rT.PtInRect(pt))
		::PostMessage(m_pTView->hWnd(),WM_REFRESH,NULL,NULL);
	else
		::PostMessage(m_pLView->hWnd(),WM_REFRESH,NULL,NULL);
	return 0;
}

LRESULT CEncSpotView::OnRename(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	::PostMessage(m_pLView->hWnd(), WM_RENAME,NULL,NULL);
	return 0;
}

LRESULT CEncSpotView::OnDelete(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	//relay from menu of CMainFrame all the way to the listview
	::PostMessage(m_pLView->hWnd(),WM_DELETE,NULL,NULL);
	return 0;
}

LRESULT CEncSpotView::OnSettings(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	CWindowWithSettings * pLV = dynamic_cast<CWindowWithSettings *>(m_pLView);
	CWindowWithSettings * pTV = dynamic_cast<CWindowWithSettings *>(m_pTView);

	BOOL dirty = FALSE;

	pTV->InitPropPages(&dirty);
	pLV->InitPropPages(&dirty);

	int startpage = wParam;

//	CPropertySheet aDlg(_T("Settings"), (startpage < 10)?startpage:0);

	CSettingsDlg aDlg(_T("Settings"), 0);

	aDlg.m_psh.dwFlags = PSH_USECALLBACK | PSH_NOAPPLYNOW;
	
	pLV->AddPropPages(&aDlg);
	pTV->AddPropPages(&aDlg);

	if (aDlg.DoModal())
	{	
		pTV->ApplyPropPageChanges(dirty);
		pLV->ApplyPropPageChanges(dirty);
		
	}
	return 0;
}

//relay to CMainFrame;
LRESULT CEncSpotView::OnStatus(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	m_pMain->PostMessage(WM_STATUS, wParam, lParam);
	return 0;
}

LRESULT CEncSpotView::OnControlAnimation(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	m_pMain->PostMessage(WM_ANIM, wParam);
	return 0;
}
LRESULT CEncSpotView::OnDetails(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{

	tstring safe;
	if (lParam)
	{
		tstring *pS = reinterpret_cast<tstring *>(lParam);
		safe = *pS;
		delete pS;
	}
	
	CInfoDlg *pDlg = NULL;
	
	
	if (wParam)
	{
		mp3data mp3;
		memset(&mp3, 0, sizeof(mp3data));
		mp3data *pm = reinterpret_cast<mp3data *>(wParam);
		mp3 = *pm;
		delete pm;

		pDlg = new CInfoDlg(safe,&mp3,m_hWnd);

	}
	else
		pDlg = new CInfoDlg(safe,NULL,m_hWnd);
	
	
	pDlg->Create(m_hWnd);
	pDlg->ShowWindow(SW_SHOW);
	m_infolist.push_back(pDlg);
	return 0;

}

LRESULT CEncSpotView::OnShellOp(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{

	CRect rL, rT;
	::GetWindowRect(m_pLView->hWnd(), &rL);
	::GetWindowRect(m_pTView->hWnd(), &rT);

	CPoint pt;
	::GetCursorPos(&pt);

	if (rT.PtInRect(pt))
		::PostMessage(m_pTView->hWnd(),WM_SHELLOP,wParam,NULL);
	else
		::PostMessage(m_pLView->hWnd(),WM_SHELLOP,wParam,NULL);

	return 0;
}



LRESULT CEncSpotView::OnSelectAll(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	::PostMessage(m_pLView->hWnd(),WM_SELECTALL,NULL,NULL);
	return 0;
}