// EncSpotView.h : interface of the CEncSpotView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENCSPOTVIEW_H__22BD64EE_00D1_11D5_A176_080046068885__INCLUDED_)
#define AFX_ENCSPOTVIEW_H__22BD64EE_00D1_11D5_A176_080046068885__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EncSpotShellSupport\pidl.h"




#include "EncSpotLib/interface.h"
#include "EncSpotLib/WinFactory.h"



class CIniFile;

//sent from CMainFrm
#define WM_SETTINGS		WM_USER+11
#define WM_STOP			WM_USER+20
#define WM_REFRESH		WM_USER+13 
#define WM_RENAME		WM_USER+14
#define WM_DELETE		WM_USER+15
#define WM_EXPORT		WM_USER+21
#define WM_SELECTALL	WM_USER+42

//to CMainFrm, + from CList
#define WM_ANIM			WM_USER+31

//sent from CEncSpotList
#define WM_DROP			WM_USER+4
#define WM_DETAILS		WM_USER+32
#define WM_STATUS		WM_USER+30

//sent by CListThread
#define WM_THREADDONE	WM_USER+6

//sent to CEncSpotList
#define WM_FILL			WM_USER+17
#define WM_SHELLOP		WM_USER+41

//from tree
#define WM_FILLLVIEW	WM_USER+35

  
class CEncSpotView :	public CSplitterWindowImpl<CEncSpotView>, 
						public CWindowWithSettings,
						public CFrameWindowStuffImpl<CEncSpotView>,
						public CCreator<CEncSpotView, WID_VIEW>
{

	CFrameWindowStuff *			m_pLView;
	CFrameWindowStuff *			m_pTView;
	CWindow *					m_pMain;
	vector<CInfoDlg *>			m_infolist;

	int							m_nSplitterPos;

public:	
	BEGIN_MSG_MAP(CEncSpotView)
		MESSAGE_HANDLER(WM_DESTROY,			OnDestroy)
		MESSAGE_HANDLER(WM_USER+10,		    OnDestroyInfoDlg)
		MESSAGE_HANDLER(WM_DROP,			OnDrop)
		MESSAGE_HANDLER(WM_SHELLOP,			OnShellOp)
		MESSAGE_HANDLER(WM_SELECTALL,		OnSelectAll)
		MESSAGE_HANDLER(WM_DETAILS,			OnDetails)
		MESSAGE_HANDLER(WM_SETTINGS,		OnSettings)
		MESSAGE_HANDLER(WM_ANIM,			OnControlAnimation)
		MESSAGE_HANDLER(WM_STOP,			OnStop)
		MESSAGE_HANDLER(WM_REFRESH,			OnRefresh)
		MESSAGE_HANDLER(WM_STATUS,			OnStatus)
		MESSAGE_HANDLER(WM_RENAME,			OnRename)
		MESSAGE_HANDLER(WM_DELETE,			OnDelete)
		MESSAGE_HANDLER(WM_EXPORT,		    OnExport)
		MESSAGE_HANDLER(WM_FILLLVIEW,		OnFillLView)
	
		REFLECT_NOTIFICATIONS() 
		CHAIN_MSG_MAP(CSplitterWindowImpl<CEncSpotView>)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)		
				
	END_MSG_MAP()

public:

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	void			SaveSettings(CIniFile &ini);
	void			LoadSettings(const CIniFile &ini);

	HWND CreateImp(HWND hWndParent = NULL, RECT *pPos=NULL)
	{
		if (pPos)
			return CWindowImpl<CEncSpotView>::Create(hWndParent, *pPos, NULL, WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_CLIENTEDGE);
		else
			return CWindowImpl<CEncSpotView>::Create(hWndParent, rcDefault, NULL, WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_CLIENTEDGE);
	}

	void Refresh();

	CEncSpotView(CWindow *pMain);
	virtual ~CEncSpotView();

	DECLARE_WND_CLASS(NULL)

private:
	LRESULT OnControlAnimation(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);		
	LRESULT OnDestroyInfoDlg(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnShellOp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnSelectAll(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnFillLView(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnStatus(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDrop(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDetails(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnSettings(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnStop(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDelete(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnRename(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnRefresh(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnExport(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		::PostMessage(m_pLView->hWnd(), WM_EXPORT,NULL,NULL);
		return 0;
	}

	
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENCSPOTVIEW_H__22BD64EE_00D1_11D5_A176_080046068885__INCLUDED_)
