// Histogram.h: interface for the CHistogram class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HISTOGRAM_H__D2141023_042C_11D5_A176_080046068885__INCLUDED_)
#define AFX_HISTOGRAM_H__D2141023_042C_11D5_A176_080046068885__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CHistogram : public CFrameWindowImpl<CHistogram,CWindow ,CWinTraits<WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_STATICEDGE> > 
{
	vector<float> m_data;
	vector<tstring>   m_labels;
	int m_acc;
	
public:
	vector<COLORREF> m_colors;
	tstring m_FontFace;
	

	void SetData(const vector<float> data) 
	{ 
		m_data.clear();
		m_data = data; 
	}

	void SetData(const float data[], int len)
	{
		m_data.clear();
		for (int i = 0;i<len;i++)
			m_data.push_back(data[i]);
	}

	void SetLabels(const vector<tstring> labels) 
	{ 
		m_labels.clear();
		m_labels = labels; 
		
	}

	void SetLabels(const tstring labels[], int len)
	{
		m_labels.clear();
		for (int i = 0;i<len;i++)
			m_labels.push_back(labels[i]);
	}

	DECLARE_WND_CLASS(_T("Histogram"))
 

	BEGIN_MSG_MAP(CHistogram)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_PAINT,  OnPaint)
	
	END_MSG_MAP()

	CHistogram(int ac);
	virtual ~CHistogram();

private:
	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
};

#endif // !defined(AFX_HISTOGRAM_H__D2141023_042C_11D5_A176_080046068885__INCLUDED_)
