// InfoDlg.h: interface for the InfoDlg class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INFODLG_H__D2141022_042C_11D5_A176_080046068885__INCLUDED_)
#define AFX_INFODLG_H__D2141022_042C_11D5_A176_080046068885__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"
#include "histogram.h"
#include "encspot.h"
#include "DetailsThread.h"

class CInfoDlg  : public CDialogImpl<CInfoDlg>, 
				  public CDialogResize<CInfoDlg>,
				  public CCustomDraw<CInfoDlg>
{
	CHistogram m_bithist, m_blockhist, m_modehist;
	tstring m_path;
	CDetailsThread m_thread;

	CListViewCtrl m_list;
	HWND		  m_hWndPar;

	BOOL		m_modehist_present;
	mp3data		m_mp3data;

	BOOL		m_fast;
public:

	enum { IDD = IDD_INFODIALOG };

	CInfoDlg(tstring path, mp3data *pMp3,HWND hWndPar);
	virtual ~CInfoDlg();

	BEGIN_DLGRESIZE_MAP(CInfoDlg)
	
		DLGRESIZE_CONTROL(IDCANCEL, DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDCANCEL, DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDC_COPY, DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_COPY, DLSZ_MOVE_Y)


		DLGRESIZE_CONTROL(IDC_CHECKPADDING, DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDC_CHECKSCFSI,   DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDC_CHECKSCALEFAC,DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDC_CHECKORIGINAL,DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDC_CHECKCOPYRIGHT,DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDC_CHECKXING,DLSZ_MOVE_Y)


		DLGRESIZE_CONTROL(IDC_CHECKPADDING, DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_CHECKSCFSI,   DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_CHECKSCALEFAC,DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_CHECKORIGINAL,DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_CHECKCOPYRIGHT,DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_CHECKXING,	DLSZ_MOVE_X)
		
		DLGRESIZE_CONTROL(IDC_GP1, DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDC_GP1, DLSZ_MOVE_X)

		DLGRESIZE_CONTROL(IDC_INFOLIST, DLSZ_MOVE_Y)
	
	END_DLGRESIZE_MAP()


	BEGIN_MSG_MAP(CInfoDlg)
		MESSAGE_HANDLER(WM_INITDIALOG,	OnInitDialog)
		MESSAGE_HANDLER(WM_CHAR,		OnKeyDown)
		MESSAGE_HANDLER(WM_USER+5,		OnReport)
		MESSAGE_HANDLER(WM_SIZE,		OnSize)
		MESSAGE_HANDLER(WM_TIMER,       OnSize)
		COMMAND_ID_HANDLER(IDOK,		OnOk)
		COMMAND_ID_HANDLER(IDC_COPY,	OnCopy)
		COMMAND_ID_HANDLER(IDCANCEL,	OnOk)
	
		CHAIN_MSG_MAP(CCustomDraw<CInfoDlg>)
		CHAIN_MSG_MAP(CDialogResize<CInfoDlg>)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnKeyDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnReport(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);

	void ResizeColumns()
	{
		m_list.SetColumnWidth(0,150);
		m_list.SetColumnWidth(1,LVSCW_AUTOSIZE_USEHEADER);
	}

	DWORD OnPrePaint(int /*idCtrl*/, LPNMCUSTOMDRAW /*lpNMCustomDraw*/)
    {		
        return  CDRF_NOTIFYITEMDRAW;
    }

	DWORD OnItemPrePaint(int /*idCtrl*/, LPNMCUSTOMDRAW lpNMCustomDraw)
    {
        NMLVCUSTOMDRAW* pLVCD = reinterpret_cast<NMLVCUSTOMDRAW*>( lpNMCustomDraw );    

        // This is the prepaint stage for an item. Here's where we set the
        // item's text color. Our return value will tell Windows to draw the
        // item itself, but it will use the new color we set here for the background     

        COLORREF crText;

        if ( (pLVCD->nmcd.dwItemSpec % 2) == 0 )
            crText = RGB(200,200,255);
        else 
            crText = RGB(255,255,255);        

        // Store the color back in the NMLVCUSTOMDRAW struct.
        pLVCD->clrTextBk = crText;

        // Tell Windows to paint the control itself.
        return CDRF_DODEFAULT;
    }

	LRESULT OnCopy(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	LRESULT OnOk(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		
		KillTimer(0);
		DestroyWindow();
	//	EndDialog(TRUE);
		return 0; 
	}
	void OnFinalMessage(HWND hWnd)
	{
		m_thread.Abort();
		m_thread.WaitForClose();
		::PostMessage(m_hWndPar,WM_USER+10,0,(LPARAM)this);
	}

private:
	void AddToList(tstring att, tstring val);

	void ProcessMp3Data();
	void MoveHistograms();
};

#endif // !defined(AFX_INFODLG_H__D2141022_042C_11D5_A176_080046068885__INCLUDED_)
 