#pragma once

#include "EncSpotShellSupport\pidl.h"
#include "encspot.h"

	typedef struct _TVItemData
	{

		
#ifdef _DEBUG
		static int ref_debug;
#endif


		_TVItemData():lpi(0),lpifq(0)
		{
			MYTRACE_1("TVITEMDATA ref: %i\r\n", ++ref_debug);
		}

		virtual ~_TVItemData()
		{
			MYTRACE_1("TVITEMDATA ref: %i\r\n", --ref_debug);
			if (spParentFolder)
				spParentFolder.Release();

			lpi.Free();
			lpifq.Free();
		}
		
		CComPtr<IShellFolder> spParentFolder;
		BOOL root;
		
		CPidl  lpi;
		CPidl  lpifq;

	} TVITEMDATA, *LPTVITEMDATA;


	typedef struct _LVItemData
	{

#ifdef _DEBUG
		static int ref_debug;
#endif

		//same if _refer_ to same file system item 
		BOOL operator==(const _LVItemData &other)
		{
			return (other.lpi.m_pidl == lpi.m_pidl);
		}
		
		_LVItemData() : bFocused(FALSE), bSelected(FALSE), spParentFolder(NULL), lpi(0), iIcon(-1), show_info(false), empty(true), read(false)
		{
			MYTRACE_1("LVITEMDATA ref: %i\r\n", ++ref_debug);
			memset(&data, 0, sizeof(mp3data));
		}
		virtual ~_LVItemData()
		{
			MYTRACE_1("LVITEMDATA ref: %i\r\n", --ref_debug);
			if (spParentFolder)
				spParentFolder->Release();

			lpi.Free();
		}
		IShellFolder *spParentFolder;

		BOOL			bFocused;
		BOOL			bSelected;
		
		CPidl			lpi;
		int				iIcon;
		bool			show_info;
		mp3data			data;
		mp3data_string	data_string;
								
		tstring name;
		tstring path;
	
		tstring null;
		bool empty;
		bool read;
	} LVITEMDATA, *LPLVITEMDATA;


	

	


