#include "stdafx.h"
#include <atlwin.h>
#include <atldlgs.h>
#include <atlctrls.h>
#include <atlctrlw.h>
#include <atlddx.h>
#include <atlmisc.h>
#include "EncSpotLib\listviewbarctrl.h"

#include "resource.h"
#include "proplist.h"

LRESULT CPropListGeneral::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{
	//center the property sheet: necessary kludge:(
	CWindow win = GetParent();
	win.CenterWindow();
	win.Detach();

	DoDataExchange(FALSE);
	bHandled = FALSE;
	return 0;
}	


LRESULT CPropListColumns::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{
	m_avlist.m_hWnd = GetDlgItem(IDC_LISTAVAILABLE);
	m_chlist.m_hWnd = GetDlgItem(IDC_LISTCHOSEN);
	m_avlist.SetExtendedListViewStyle(LVS_EX_FULLROWSELECT,LVS_EX_FULLROWSELECT);		
	m_chlist.SetExtendedListViewStyle(LVS_EX_FULLROWSELECT,LVS_EX_FULLROWSELECT);		
	
	m_avlist.AddColumn(_T(""),0);
	m_chlist.AddColumn(_T(""),0);

	for (int i = 0;i<m_chcolumns.size();i++)
		m_chlist.InsertItem( LVIF_TEXT, i,m_chcolumns[i].c_str(),0,0,0,0);
	for (i = 0;i<m_avcolumns.size();i++)
		m_avlist.InsertItem( LVIF_TEXT, i,m_avcolumns[i].c_str(),0,0,0,0);

	m_avlist.SetColumnWidth(0,LVSCW_AUTOSIZE_USEHEADER);
	m_chlist.SetColumnWidth(0,LVSCW_AUTOSIZE_USEHEADER);
	
	CheckDlgButton(IDC_AUTOSIZE, m_autosize?BST_CHECKED:BST_UNCHECKED);

	bHandled = FALSE;
	return 0;
}

BOOL CPropListColumns::DrawBar(CListViewBarCtrl &m_lview)
{

	if (m_lview.GetItemCount() == 0)
		return FALSE;

	POINT pt;
	GetCursorPos(&pt);
	m_lview.ScreenToClient(&pt);
	UINT flags;
	int i = m_lview.HitTest(pt,&flags);

	if ( (i==-1) && !(flags & LVHT_NOWHERE))
	{
		if (m_lview.m_bBarActive)
		{
			m_lview.EraseBar();
			m_lview.m_bBarActive = FALSE;
		}
		return FALSE;
	}

	

	CRect r;
	if (i == -1)
	{
		m_lview.GetItemRect(m_lview.GetItemCount() - 1,&r,LVIR_LABEL);
		if (pt.y < r.bottom)
			return FALSE;
	}

	m_lview.m_bBarActive = TRUE;
	if (!(i==m_lview.m_nBarPos))
	{
		m_lview.EraseBar();
		m_lview.m_nBarPos    = i;
		m_lview.DrawBar();
	}
	return TRUE;

}



LRESULT CPropListQuality::OnColor (WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{

	CColorDialog aDlg;

	
	aDlg.m_cc.Flags |= CC_RGBINIT | CC_FULLOPEN;

	if (wID == IDC_GOOD)
		aDlg.m_cc.rgbResult = m_cols[2];
	else if (wID == IDC_NOTBAD)
		aDlg.m_cc.rgbResult = m_cols[1];
	else if (wID == IDC_BAD)
		aDlg.m_cc.rgbResult = m_cols[0];


	if (aDlg.DoModal())
	{
		if (wID == IDC_GOOD)
			m_cols[2] = aDlg.GetColor();
		else if (wID == IDC_NOTBAD)
			m_cols[1] = aDlg.GetColor();
		else if (wID == IDC_BAD)
			m_cols[0] = aDlg.GetColor();
	}
	return 0;
}


LRESULT CPropListQuality::OnDrawItem(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
{
	LPDRAWITEMSTRUCT lpdi = reinterpret_cast<LPDRAWITEMSTRUCT>(lParam);
	HWND hWnd = lpdi->hwndItem;
	CDCT<false> dc = lpdi->hDC;

	COLORREF col;

	if (hWnd == GetDlgItem(IDC_GOOD))
		col = m_cols[2];
	else if (hWnd == GetDlgItem(IDC_NOTBAD))
		col = m_cols[1];
	else if (hWnd == GetDlgItem(IDC_BAD))
		col = m_cols[0];

	int old = dc.SaveDC();

	CBrushT<true> brush;
	brush.CreateSolidBrush(col);

	RECT r;
	::GetClientRect(hWnd,&r);
	dc.FillRect(&r,brush);

	dc.RestoreDC(old);
	return 0;
}




LRESULT CPropListColumns::OnBeginDrag(int idCtrl, LPNMHDR pnmh, BOOL& bHandled)
{
	::SetFocus(GetDlgItem(idCtrl));
	
	::SetCapture(m_hWnd);
	SetCursor(LoadCursor(_Module.GetModuleInstance(),MAKEINTRESOURCE(IDC_DROPMOVE)));
	return 0;
}

LRESULT CPropListColumns::OnLButtonUp	(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if (!GetCapture())
		return 0;

	ReleaseCapture();

	SetCursor(LoadCursor(NULL,IDC_ARROW));

	m_avlist.InvalidateRect(NULL);
	m_chlist.InvalidateRect(NULL);
	

	HWND hwndFocus = GetFocus();

	POINT Pt;
	GetCursorPos(&Pt);
	HWND hwndcur = NULL;

	CRect r1,r2;
	m_avlist.GetWindowRect(r1);
	m_chlist.GetWindowRect(r2);

	if (r1.PtInRect(Pt))
		hwndcur = m_avlist;
	else if (r2.PtInRect(Pt))
		hwndcur = m_chlist;
	else return 0;


	m_avlist.EraseBar();
	m_chlist.EraseBar();

	m_avlist.m_bBarActive = FALSE;
	m_chlist.m_bBarActive = FALSE;

	if (hwndFocus == hwndcur)
	{
		if (hwndFocus == m_avlist.m_hWnd)
			MoveItem(m_avlist);
		else
			MoveItem(m_chlist);
	}
	else
	{
		if (hwndcur == m_avlist)		//removing a column
			MoveItem(m_chlist, m_avlist);
		else
			MoveItem(m_avlist, m_chlist);
	}



	return 0;
}

int CPropListColumns::InsertAt(CListViewBarCtrl &lview, TCHAR *txt, LPARAM lParam, int sel)
{
	POINT pt;
	GetCursorPos(&pt);
	lview.ScreenToClient(&pt);
	UINT flags;

	int i = lview.HitTest(pt,&flags);
	if ( (i==-1) && !(flags & LVHT_NOWHERE))
		return 0;

	if (i == -1)
	{
		CRect r;
		lview.GetItemRect(lview.GetItemCount() - 1,&r,LVIR_LABEL);

		if (pt.y < r.bottom)
			return 0;

		lview.InsertItem(LVIF_PARAM | LVIF_TEXT, lview.GetItemCount(),txt,0,0,0,lParam);
		return 1;

		
	}
	else
	{
		lview.InsertItem(LVIF_PARAM | LVIF_TEXT, i ,txt,0,0,0,lParam);
		return (i<sel)?-1:1;
	}



}



void CPropListColumns::MoveItem(CListViewBarCtrl &lview)
{
	if (lview.GetItemCount() == 0)
		return;

	int sel = lview.GetSelectionMark();
	if (sel==-1)
		return;

	LPARAM lParam = lview.GetItemData(sel);
	TCHAR txt[256];
	lview.GetItemText(sel,0,txt,sizeof(txt));

	switch(InsertAt(lview,txt,lParam,sel))
	{
	case 1:
		lview.DeleteItem(sel);
		break;
	case -1:
		lview.DeleteItem(sel+1);
		break;
	}
}

void CPropListColumns::MoveItem(CListViewBarCtrl &m_from, CListViewBarCtrl &m_to)
{

	int i = m_from.GetSelectionMark();
	if (i == -1)
		return;

	LPARAM lParam = m_from.GetItemData(i);
	TCHAR szText[256];
	m_from.GetItemText(i,0,szText,sizeof(szText));

	InsertAt(m_to,szText,lParam,0);
	m_from.DeleteItem(i);

	m_to.SetColumnWidth(0,LVSCW_AUTOSIZE_USEHEADER);
	m_from.SetColumnWidth(0,LVSCW_AUTOSIZE_USEHEADER);
}



BOOL CPropListColumns::OnApply()
{
	m_chcolumns.clear();
	for (int i = 0;i<m_chlist.GetItemCount();i++)
	{
		TCHAR label[256];
		m_chlist.GetItemText(i,0,label,sizeof(label));
		m_chcolumns.push_back(label);
	}

	m_autosize = (IsDlgButtonChecked(IDC_AUTOSIZE)==BST_CHECKED);
	return TRUE;
}
