#pragma once

class CPropListColumns : public CPropertyPageImpl<CPropListColumns> 
{
	
public:
	BOOL m_autosize;
	BOOL *m_pDirty;
	vector<tstring> m_avcolumns, m_chcolumns;

	enum { IDD = IDD_SETTINGSCOLUMNS };

	BEGIN_MSG_MAP(CPropListColumns)
		
		MESSAGE_HANDLER(WM_INITDIALOG,		OnInitDialog)
		MESSAGE_HANDLER(WM_LBUTTONUP,		OnLButtonUp)
		MESSAGE_HANDLER(WM_MOUSEMOVE,		OnMouseMove)
		
		NOTIFY_CODE_HANDLER(LVN_BEGINDRAG,	OnBeginDrag)

		CHAIN_MSG_MAP(CPropertyPageImpl<CPropListColumns>)
	END_MSG_MAP()

	BOOL OnApply();

private:
	int		InsertAt(CListViewBarCtrl &lview, TCHAR *txt, LPARAM lParam,int sel);
	void	MoveItem(CListViewBarCtrl &m_lview);
	void	MoveItem(CListViewBarCtrl &m_from, CListViewBarCtrl &m_to);
	BOOL	DrawBar(CListViewBarCtrl &m_lview);
			
	CListViewBarCtrl m_avlist,m_chlist;

	
	LRESULT OnBeginDrag(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
	LRESULT OnLButtonUp	(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
		
	LRESULT OnMouseMove(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		if (!GetCapture())
			return 0;

		DrawBar(m_avlist);
		DrawBar(m_chlist);

		return 0;
	}
};




class CPropListQuality : public CPropertyPageImpl<CPropListQuality>,public CWinDataExchange<CPropListQuality> 
{
public:

	BOOL *m_pDirty;

	COLORREF	m_cols[3]; 
	BOOL		m_monoquality;
	enum { IDD = IDD_SETTINGSQUALITY };

	BEGIN_MSG_MAP(CPropListQuality)
	
		COMMAND_ID_HANDLER(IDC_GOOD,    OnColor)
		COMMAND_ID_HANDLER(IDC_BAD ,    OnColor)
		COMMAND_ID_HANDLER(IDC_NOTBAD,  OnColor)

		MESSAGE_HANDLER(WM_DRAWITEM,	OnDrawItem)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	
		CHAIN_MSG_MAP(CPropertyPageImpl<CPropListQuality>)
	END_MSG_MAP()

	BEGIN_DDX_MAP(CPropListQuality)
		DDX_CHECK(IDC_CHECKMONO,m_monoquality)
	END_DDX_MAP()
	LRESULT OnDrawItem(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		DoDataExchange(FALSE);
		bHandled = FALSE;

		return 0;
	}


	LRESULT OnColor (WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

	BOOL OnApply()
	{
		BOOL oldquality = m_monoquality;
		DoDataExchange(TRUE);

		if (m_monoquality!=oldquality)
			*m_pDirty = TRUE;
		
		return TRUE;
	}
};




class CPropListGeneral :	public CPropertyPageImpl<CPropListGeneral>,
						public CWinDataExchange<CPropListGeneral> 
{
public:
	int		m_frameres;
	BOOL	m_readallunknown;
	BOOL	m_initial;

	BOOL *m_pDirty;

	enum { IDD = IDD_PROPGENERAL };

	BEGIN_MSG_MAP(CPropListGeneral)	
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)	
		CHAIN_MSG_MAP(CPropertyPageImpl<CPropListGeneral>)
	END_MSG_MAP()

	BEGIN_DDX_MAP(CPropListGeneral)
		DDX_INT(IDC_FRAMERES,		m_frameres)
		DDX_CHECK(IDC_READALLUNKNOWN, m_readallunknown)
		DDX_CHECK(IDC_INITIAL, m_initial)
	END_DDX_MAP()
 
	BOOL OnApply()
	{
		int		oldframe	= m_frameres;
		BOOL	oldread		= m_readallunknown;
		BOOL	oldinit		= m_initial;
		DoDataExchange(TRUE);

		if (oldframe != m_frameres)
			*m_pDirty = TRUE;

		if (oldread != m_readallunknown)
			*m_pDirty = TRUE;

		if (oldinit != m_initial)
			*m_pDirty = TRUE;

		return TRUE;
	}
	
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);

	
	
};