// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__22BD64EB_00D1_11D5_A176_080046068885__INCLUDED_)
#define AFX_MAINFRM_H__22BD64EB_00D1_11D5_A176_080046068885__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "resource.h"
#include "encspot.h"
#include "EncSpotLib/interface.h"
#include "EncSpotLib/WinFactory.h"


//defines for CEncSpotView
#define WM_SETTINGS WM_USER+11
#define WM_STOP		WM_USER+20
#define WM_REFRESH	WM_USER+13
#define WM_RENAME	WM_USER+14
#define WM_DELETE	WM_USER+15
#define WM_EXPORT	WM_USER+21
#define WM_SHELLOP	WM_USER+41
#define WM_SELECTALL WM_USER+42

//from CEncSpotView
#define WM_STATUS		WM_USER+30
#define WM_ANIM			WM_USER+31
  

class CIniFile;
class CHyperLink;

class CMainFrame :	public CFrameWindowImpl<CMainFrame>, 
					public CUpdateUI<CMainFrame>,
					public CMessageFilter, 
					public CIdleHandler,
					public CWindowWithSettings,
					public CFrameWindowStuffImpl<CMainFrame>,
					public CCreator<CMainFrame, WID_MAINFRAME>
{
	void			SaveSettings(CIniFile &ini);
	void			LoadSettings(const CIniFile &ini);

public:



	void StatusReport(int panel, tstring status);
	DECLARE_FRAME_WND_CLASS(NULL, IDR_MAINFRAME)

	CFrameWindowStuff *		m_pView;
	CStatusBarCtrl			m_status;
	CImageList				m_toolimages;
	BOOL					m_bMaximize;

	CMainFrame(CWindow *pParent);
	virtual ~CMainFrame();

	CCommandBarCtrl m_CmdBar;
	CAnimateCtrl	m_animate;

	RECT m_InitRect;

	virtual BOOL PreTranslateMessage(MSG* pMsg)
	{
		if(CFrameWindowImpl<CMainFrame>::PreTranslateMessage(pMsg))
			return TRUE;

		
		return m_pView->PreTranslateMessage(pMsg);
	}

	static BOOL AddComplicatedReBarBandCtrl(HWND hWndReBar, HWND hWndBand, int nID = 0, LPTSTR lpstrTitle = NULL, BOOL bNewRow = FALSE, int cxWidth = 0, BOOL bFullWidthAlways = FALSE,UINT fExtraStyles  = 0);


	virtual BOOL OnIdle()
	{
		UIUpdateToolBar();
		return FALSE;
	}

	BEGIN_MSG_MAP(CMainFrame)
		MESSAGE_HANDLER(WM_CREATE,			OnCreate)
		MESSAGE_HANDLER(WM_MOVING,			OnMoving)
		MESSAGE_HANDLER(WM_SIZING,			OnSizing)
		MESSAGE_HANDLER(WM_DESTROY,			OnDestroy)
		MESSAGE_HANDLER(WM_STATUS,			OnUpdateStatusBar)
		MESSAGE_HANDLER(WM_ANIM,			OnControlAnimation)
		MESSAGE_HANDLER(WM_SIZE,			OnSize)
		COMMAND_ID_HANDLER(ID_APP_EXIT, OnFileExit)
		COMMAND_ID_HANDLER(ID_VIEW_TOOLBAR, OnViewToolBar)
		COMMAND_ID_HANDLER(ID_VIEW_STATUS_BAR, OnViewStatusBar)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)

		COMMAND_ID_HANDLER(ID_EDIT_DELETE, OnEditDelete)
		COMMAND_ID_HANDLER(ID_EDIT_RENAME, OnEditRename)

		COMMAND_ID_HANDLER(ID_EDIT_CUT,		OnShellAccel)
		COMMAND_ID_HANDLER(ID_EDIT_COPY,	OnShellAccel)
		COMMAND_ID_HANDLER(ID_EDIT_PASTE,	OnShellAccel)
		COMMAND_ID_HANDLER(ID_EDIT_SELECTALL,OnSelectAll)


		COMMAND_ID_HANDLER(IDOPTIONS, OnSettings)
		COMMAND_ID_HANDLER(ID_REFRESH,OnRefresh)
		COMMAND_ID_HANDLER(ID_STOP,   OnStop)
		COMMAND_ID_HANDLER(ID_EXPORT, OnExport)

		COMMAND_ID_HANDLER(ID_HELP,   OnHelp)

		COMMAND_ID_HANDLER(ID_LOGGING,	OnLogging);
		COMMAND_ID_HANDLER(ID_JUNK,		OnJunk);
		
		CHAIN_MSG_MAP(CUpdateUI<CMainFrame>)
		CHAIN_MSG_MAP(CFrameWindowImpl<CMainFrame>)
	END_MSG_MAP()

	BEGIN_UPDATE_UI_MAP(CMainFrame)
		UPDATE_ELEMENT(ID_VIEW_TOOLBAR, UPDUI_MENUPOPUP)
		UPDATE_ELEMENT(ID_VIEW_STATUS_BAR, UPDUI_MENUPOPUP)
		UPDATE_ELEMENT(ID_LOGGING, UPDUI_MENUPOPUP)
	END_UPDATE_UI_MAP()

	HWND CreateImp(HWND hWndParent = NULL, RECT *pPos=NULL)
	{
		return CFrameWindowImpl<CMainFrame>::CreateEx(); 
	}


private:
	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnMoving(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnSizing(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnUpdateStatusBar(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnControlAnimation(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);

	LRESULT OnSettings(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnRefresh(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnStop(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnLogging(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnJunk(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	LRESULT OnEditDelete(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnShellAccel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnEditRename(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnSelectAll(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		::PostMessage(m_pView->hWnd(),WM_SELECTALL,NULL,NULL);
		return 0;
	}
	LRESULT OnExport(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		::PostMessage(m_pView->hWnd(), WM_EXPORT,NULL,NULL);
		return 0;
	}



	LRESULT OnFileExit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}

	LRESULT OnViewToolBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		static BOOL bNew = TRUE;	// initially visible
		bNew = !bNew;
		::SendMessage(m_hWndToolBar, RB_SHOWBAND, 1, bNew);	// toolbar is band #1
		UISetCheck(ID_VIEW_TOOLBAR, bNew);
		UpdateLayout();
		return 0;
	}

	LRESULT OnViewStatusBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		BOOL bNew = !::IsWindowVisible(m_hWndStatusBar);
		::ShowWindow(m_hWndStatusBar, bNew ? SW_SHOWNOACTIVATE : SW_HIDE);
		UISetCheck(ID_VIEW_STATUS_BAR, bNew);
		UpdateLayout();
		return 0;
	}

	LRESULT OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnHelp(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__22BD64EB_00D1_11D5_A176_080046068885__INCLUDED_)
